public inbox for linux-kernel@vger.kernel.org
 help / color / mirror / Atom feed
From: Masami Hiramatsu <mhiramat@kernel.org>
To: Steven Rostedt <rostedt@goodmis.org>, linux-kernel@vger.kernel.org
Cc: mhiramat@kernel.org, Ingo Molnar <mingo@redhat.com>,
	Namhyung Kim <namhyung@kernel.org>,
	Tom Zanussi <tom.zanussi@linux.intel.com>,
	Arnaldo Carvalho de Melo <acme@kernel.org>,
	linux-trace-users@vger.kernel.org,
	linux-kselftest@vger.kernel.org, shuah@kernel.org
Subject: [PATCH v4 19/19] selftests: ftrace: Add a testcase for array type with kprobe_event
Date: Wed, 28 Feb 2018 12:28:40 +0900	[thread overview]
Message-ID: <151978851997.2577.2012127759002018319.stgit@devbox> (raw)
In-Reply-To: <151978796240.2577.6531711990653677529.stgit@devbox>

Add a testcase for array type with kprobe event.
This tests good/bad syntax combinations and also
the traced data is correct in several way.
If the kernel doesn't support array type, it skips
the test as UNSUPPORTED.

Signed-off-by: Masami Hiramatsu <mhiramat@kernel.org>
---
 Changes in v4:
  - Add format field tests.
---
 .../ftrace/test.d/kprobe/kprobe_args_array.tc      |   92 ++++++++++++++++++++
 1 file changed, 92 insertions(+)
 create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_array.tc

diff --git a/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_array.tc b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_array.tc
new file mode 100644
index 000000000000..0d0450b858fc
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_array.tc
@@ -0,0 +1,92 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: Kprobe event array argument
+
+[ -f kprobe_events ] || exit_unsupported # this is configurable
+
+grep -q "<type>\[<array-size>\]" README || exit_unsupported # version issue
+
+GOODSYM="_sdata"
+if ! grep -qw ${GOODSYM} /proc/kallsyms ; then
+  GOODSYM="create_trace_kprobe"
+fi
+case `uname -m` in
+x86_64)
+  ARG2=%si
+  OFFS=8
+  BITS=64
+;;
+i[3456]86)
+  ARG2=%cx
+  OFFS=4
+  BITS=32
+;;
+aarch64)
+  ARG2=%x1
+  OFFS=8
+  BITS=64
+;;
+arm*)
+  ARG2=%r1
+  OFFS=4
+  BITS=32
+;;
+*)
+  echo "Please implement other architecture here"
+  exit_untested
+esac
+
+create_testprobe() { # args
+  echo "p:testprobe create_trace_kprobe $*" > kprobe_events
+}
+
+check_field() { # grep-pattern
+  grep -e "$*" events/kprobes/testprobe/format
+}
+
+echo 0 > events/enable
+echo > kprobe_events
+
+: "Syntax test"
+create_testprobe "+0(${ARG2}):x8[1] +0(${ARG2}):s16[1] +0(${ARG2}):u32[1]"
+check_field "field:u8 arg1\[1\];.*size:1;"
+check_field "field:s16 arg2\[1\];.*size:2;"
+check_field "field:u32 arg3\[1\];.*size:4;"
+create_testprobe "+0(${ARG2}):x64[1] +0(${ARG2}):symbol[1]"
+check_field "field:u64 arg1\[1\];.*size:8;"
+check_field "field:u${BITS} arg2\[1\];.*size:${OFFS};"
+create_testprobe "+0(${ARG2}):b2@3/8[1] +0(${ARG2}):string[1]"
+check_field "field:u8 arg1\[1\];.*size:1;"
+check_field "field:__data_loc char\[\]\[1\] arg2;.*size:4;"
+create_testprobe "+0(${ARG2}):x8[64] @${GOODSYM}:x8[4]"
+check_field "field:u8 arg1\[64\];.*size:64;"
+check_field "field:u8 arg2\[4\];.*size:4;"
+
+! create_testprobe "${ARG2}:x8[1]" # Can not use array type on register
+! create_testprobe "\$comm:x8[1]" # Can not use array type on \$comm
+! create_testprobe "\$comm:string[1]" # No, even if it is string array
+! create_testprobe "+0(${ARG2}):x64[0]" # array size >= 1
+! create_testprobe "+0(${ARG2}):x64[65]" # array size <= 64
+
+: "Test get argument (1)"
+create_testprobe "arg1=+0(${ARG2}):string[1]" > kprobe_events
+echo 1 > events/kprobes/testprobe/enable
+! echo test >> kprobe_events
+tail -n 1 trace | grep -qe "testprobe.* arg1={\"test\"}"
+echo 0 > events/kprobes/testprobe/enable
+
+: "Test get argument (2)"
+create_testprobe "arg1=+0(${ARG2}):string[3]" > kprobe_events
+echo 1 > events/kprobes/testprobe/enable
+! echo foo bar buzz >> kprobe_events
+tail -n 1 trace | grep -qe "testprobe.* arg1={\"foo\",\"bar\",\"buzz\"}"
+echo 0 > events/kprobes/testprobe/enable
+
+: "Test get argument (3)"
+create_testprobe "arg1=+0(+0(${ARG2})):u8[4]" > kprobe_events
+echo 1 > events/kprobes/testprobe/enable
+! echo 1234 >> kprobe_events
+tail -n 1 trace | grep -qe "testprobe.* arg1={49,50,51,52}" # ascii code
+echo 0 > events/kprobes/testprobe/enable
+
+echo > kprobe_events


      parent reply	other threads:[~2018-02-28  3:29 UTC|newest]

Thread overview: 26+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-02-28  3:19 [PATCH v4 00/19] tracing: probeevent: Improve fetcharg features Masami Hiramatsu
2018-02-28  3:19 ` [PATCH v4 01/19] [BUGFIX] tracing: probeevent: Fix to support minus offset from symbol Masami Hiramatsu
2018-03-02  4:49   ` Namhyung Kim
2018-03-02  6:32     ` Masami Hiramatsu
2018-03-05  2:28       ` Namhyung Kim
2018-03-05 10:05         ` Masami Hiramatsu
2018-02-28  3:20 ` [PATCH v4 02/19] selftests: ftrace: Add probe event argument syntax testcase Masami Hiramatsu
2018-02-28  3:20 ` [PATCH v4 03/19] selftests: ftrace: Add a testcase for string type with kprobe_event Masami Hiramatsu
2018-02-28  3:21 ` [PATCH v4 04/19] selftests: ftrace: Add a testcase for probepoint Masami Hiramatsu
2018-02-28  3:21 ` [PATCH v4 05/19] tracing: probeevent: Cleanup print argument functions Masami Hiramatsu
2018-02-28  3:22 ` [PATCH v4 06/19] tracing: probeevent: Cleanup argument field definition Masami Hiramatsu
2018-02-28  3:22 ` [PATCH v4 07/19] tracing: probeevent: Remove NOKPROBE_SYMBOL from print functions Masami Hiramatsu
2018-02-28  3:23 ` [PATCH v4 08/19] tracing: probeevent: Introduce new argument fetching code Masami Hiramatsu
2018-02-28  3:23 ` [PATCH v4 09/19] tracing: probeevent: Unify fetch type tables Masami Hiramatsu
2018-02-28  3:24 ` [PATCH v4 10/19] tracing: probeevent: Return consumed bytes of dynamic area Masami Hiramatsu
2018-02-28  3:24 ` [PATCH v4 11/19] tracing: probeevent: Append traceprobe_ for exported function Masami Hiramatsu
2018-02-28  3:25 ` [PATCH v4 12/19] tracing: probeevent: Unify fetch_insn processing common part Masami Hiramatsu
2018-02-28  3:25 ` [PATCH v4 13/19] tracing: probeevent: Add symbol type Masami Hiramatsu
2018-02-28  3:26 ` [PATCH v4 14/19] x86: ptrace: Add function argument access API Masami Hiramatsu
2018-02-28  3:26 ` [PATCH v4 15/19] tracing: probeevent: Add $argN for accessing function args Masami Hiramatsu
2018-02-28  3:27 ` [PATCH v4 16/19] tracing: probeevent: Add array type support Masami Hiramatsu
2018-02-28  3:27 ` [PATCH v4 17/19] selftests: ftrace: Add a testcase for symbol type Masami Hiramatsu
2018-02-28  3:28 ` [PATCH v4 18/19] selftests: ftrace: Add a testcase for $argN with kprobe_event Masami Hiramatsu
2018-03-02  5:31   ` Namhyung Kim
2018-03-02  6:20     ` Masami Hiramatsu
2018-02-28  3:28 ` Masami Hiramatsu [this message]

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=151978851997.2577.2012127759002018319.stgit@devbox \
    --to=mhiramat@kernel.org \
    --cc=acme@kernel.org \
    --cc=linux-kernel@vger.kernel.org \
    --cc=linux-kselftest@vger.kernel.org \
    --cc=linux-trace-users@vger.kernel.org \
    --cc=mingo@redhat.com \
    --cc=namhyung@kernel.org \
    --cc=rostedt@goodmis.org \
    --cc=shuah@kernel.org \
    --cc=tom.zanussi@linux.intel.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox